
/*

Holds class definitions for inference model

Written by Richard Power
Copyright (c) 2013 by Open University

This package is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 3 of the License, or (at your option) any later version.

The package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Library General Public License for more details.

*/

public class Definition
{ private int defType;
  private ModelTerm definedTerm;
  private ModelTerm argument0;
  private ModelTerm argument1;

  public Definition(ModelTerm arg1, int arg2, ModelTerm arg3, ModelTerm arg4)
  { definedTerm = arg1;
    defType = arg2;
    argument0 = arg3;
    argument1 = arg4;
  }

  public ModelTerm getDefinedTerm() {return definedTerm; }
  public int getType() {return defType; }
  public ModelTerm getArg0() {return argument0; }
  public ModelTerm getArg1() {return argument1; }

  public void display()
  { if (defType == Model.RESTRICTION) System.out.println("RESTRICTION");
    else System.out.println("CONJUNCTION");
    definedTerm.display();
    System.out.println();
    argument0.display();
    System.out.println();
    argument1.display();
    System.out.println();
  }

  public String report()
  { String s = definedTerm.getReportName();
    s = s + " = ";
    if (defType == Model.CONJUNCTION) s = s + "CONJUNCTION(";
    else s = s + "RESTRICTION(";
    s = s + argument0.getReportName() + ", ";
    s = s + argument1.getReportName() + ")";
    return s;
  }

}
