
/*

A glossary is a text organised alphabetically into sections, one for each entity

Written by Richard Power
Copyright (c) 2013 by Open University

This package is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 3 of the License, or (at your option) any later version.

The package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Library General Public License for more details.

*/

import java.util.*;
import java.lang.String;

public class Glossary
{ private String textString;
  private Model model;
  private TreeMap<String,GlossaryEntry> entries;
  
  public Glossary(Model arg)
  { model = arg;
    makeGlossary();
    makeText();
  }

  public String getText() { return textString; }

  private void makeGlossary()
  { entries = new TreeMap<String,GlossaryEntry>();
    String name = "";
    for (ModelTerm term : model.getClasses())
    if (term.getSource()==Model.ORIGINAL)
    { GlossaryEntry entry = new GlossaryEntry(term,model);
      name = term.getName();
      if (name.startsWith("the ")) name = name.replaceFirst("the","The");
      entries.put(name,entry);
    }
  }

  private void makeText()
  { textString = "";
    for (String s : entries.keySet())
    textString = textString + "\n" + entries.get(s).getType() +
                 " " + s + "\n" + entries.get(s).getText();
  }

  public void display()
  { System.out.println(textString);
  }

}
