
/*

Holds terms for inference model

Written by Richard Power
Copyright (c) 2013 by Open University

This package is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 3 of the License, or (at your option) any later version.

The package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Library General Public License for more details.

==========================================================

Each term comprises a name, type, source, and category:

Name is a string such as "lives in a kennel"
Type is CLASS|INDIVIDUAL|PROPERTY
Source is ORIGINAL|DEFINED
Category is NOUN_PHRASE|VERB_PHRASE

*/

import java.util.Vector;
import java.util.Collections;
import java.lang.String;

public class ModelTerm
{ private String entityName;
  private int entityType;
  private int entitySource;
  private int category;

  public ModelTerm(int arg1, String arg2, int arg3, int arg4)
  { entityType = arg1;
    entityName = arg2;
    entitySource = arg3;
    category = arg4;
  }

  public String getName() {return entityName; }
  public int getType() {return entityType; }
  public int getSource() {return entitySource; }
  public int getCategory() {return category; }

  public void setName(String arg) {entityName = arg; }
  public void setType(int arg) {entityType = arg; }
  public void setSource(int arg) {entitySource = arg; }
  public void setCategory(int arg) {category = arg; }

  public String getReportName()
  { String name = entityName;
    if ((entityType == Model.CLASS) && (category == Model.VERB_PHRASE))
    name = "thing that " + name;
    return name;
  }

  public void display()
  { System.out.print("[");
    System.out.print(this);
    if (entityType == Model.PROPERTY) System.out.print("PROPERTY");
    else if (entityType == Model.INDIVIDUAL) System.out.print("INDIVIDUAL");
    else System.out.print("CLASS");
    System.out.print(",");
    if (entitySource == Model.DEFINED) System.out.print("DEFINED");
    else System.out.print("ORIGINAL");
    System.out.print(",");
    if (category == Model.VERB_PHRASE) System.out.print("VP");
    else System.out.print("NP");
    System.out.print("," + entityName + "]");
  }

}
